This issue tracker has been migrated to GitHub, and is currently read-only.
For more information, see the GitHub FAQs in the Python's Developer Guide.

classification
Title: Incorrect line numbers in GDB Python backtraces [3.9]
Type: behavior Stage: resolved
Components: Demos and Tools Versions: Python 3.9, Python 3.8, Python 3.7, Python 3.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: colesbury, lukasz.langa
Priority: normal Keywords: patch

Created on 2021-11-18 19:08 by colesbury, last changed 2022-04-11 14:59 by admin. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 29628 merged colesbury, 2021-11-18 19:31
Messages (3)
msg406560 - (view) Author: Sam Gross (colesbury) * (Python triager) Date: 2021-11-18 19:08
Starting in Python 3.6 the line numbers table contains a *signed* byte indicating line delta. The calculation in Tools/gdb/libpython.py was not updated to handle signed bytes leading to incorrect line numbers when running "py-bt" (or printing frames) in GDB.

This issue does not exist in Python 3.10 or later because line number table was changed (and libpython.py was updated) in GH-23113.
msg406611 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2021-11-19 18:53
New changeset 2a32dbf110cf80ec9a00290ea6bc84f409948cb0 by Sam Gross in branch '3.9':
[3.9] bpo-45838: Fix incorrect line numbers in Tools/gdb/libpython.py (GH-29628)
https://github.com/python/cpython/commit/2a32dbf110cf80ec9a00290ea6bc84f409948cb0
msg406612 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2021-11-19 18:54
Thanks, Sam! ✨ 🍰 ✨
History
Date User Action Args
2022-04-11 14:59:52adminsetgithub: 89996
2021-11-19 18:54:24lukasz.langasetstatus: open -> closed
resolution: fixed
messages: + msg406612

stage: patch review -> resolved
2021-11-19 18:53:54lukasz.langasetnosy: + lukasz.langa
messages: + msg406611
2021-11-18 19:31:16colesburysetkeywords: + patch
stage: patch review
pull_requests: + pull_request27860
2021-11-18 19:08:45colesburycreate